<template>
<div
	:class="class_name"
	v-on:click="onClick"
	v-on:mouseover="onHover"
>
	<slot />
	<input ref="slider" type="range" min="0" max="100" step="1" :value="value" v-on:input="onType" />
</div>
</template>

<script>
export default {
	computed: {
		class_name: function () {
			return {
				[this.size]: true,
				item: true,
				selected: this.selected
			}
		},
		size: function () {
			return this.config ? this.config.size : "normal"
		}
	},
	created () {
		this.$on("PRESS_LEFT", () => {
			const ref = this.$refs.slider
			ref.value = Math.max(0, +ref.value - 10)
			this.onType()
		})
		this.$on("PRESS_RIGHT", () => {
			const ref = this.$refs.slider
			ref.value = Math.min(100, +ref.value + 10)
			this.onType()
		})
		this.$on("PRESS_ENTER", () => {
			this.blur()
		})
	},
	data () {
		return { focused: false }
	},
	methods: {
		onClick: function () {
		},
		onHover: function () {
			this.$emit("hover", this.id)
		},
		onType: function () {
			const ref = this.$refs.slider
			this.$emit("change", this.id, ref.value)
		}
	},
	name: "slider-item",
	props: [ "config", "id", "selected", "value" ],
	updated () {
		if (!this.selected) this.$refs.slider.blur()
	}
}
</script>

<style lang="less" src="./styles/Item.less" scoped></style>